Subject: bug#11939: 24.1; `save-buffers-kill-emacs' loses minibuffer focuswhenitcalls `list-processes'

From: "Drew Adams" <[email-masked]>
Date: Sun, 5 Aug 2012 15:32:06 -0700

>  > Anyway, with 24.1 I immediately ran into this problem: `q' 
>  > in *Help* did not remove the frame.  It just substituted the
>  > previously current buffer in that frame.
> 
> Do you mean the frame did show another buffer before?  

No, never.  What it substituted in the *Help* frame was a buffer that was
previously selected elsewhere (it was never displayed in the *Help* frame).

> Anyway, that's a different issue.

Yes, I imagine so.  But I thought you might like to know about it.  Without
loading your code I do not have that problem: buffer *Help* is never replaced in
its frame by any other buffer.  It is a special-display buffer.

> The code is supposed only for testing with the three
> functions `recover-file', `save-buffers-kill-emacs' and
> `dired-mark-pop-up'.  It's possible that some of my changes 
> also affect quitting *Help* windows and the like.

> Tell me the value of the *Help*
> window's `quit-restore' parameter.

Before loading your code there is no such parameter present.
Likewise after loading it: no such parameter.

This is the code that defines the *Help* frame parameters:

(add-to-list
  'special-display-buffer-names
  (list "*Help*" '1on1-display-*Help*-frame
        (list (cons 'background-color 1on1-help-frame-background)
              (cons 'mouse-color 1on1-help-frame-mouse+cursor-color)
              (cons 'cursor-color 1on1-help-frame-mouse+cursor-color)
              '(height . 40))))

>  > IOW, the *Help* frame is apparently no longer 
>  > special-display as it should be.
> 
> It still is and should call `frame-auto-hide-function'.

No idea what that means.  It clearly does not behave like a special-display
frame: its frame is not dedicated.

FWIW, (special-display-p "*Help*") returns this:

(1on1-display-*Help*-frame
 ((background-color . "Thistle")
  (mouse-color . "Blue Violet")
  (cursor-color . "Blue Violet")
  (height . 40)))